#!/usr/bin/env python
#   -*- encoding:   UTF-8   -*-

"""
    'The Web is Dead' (TWID) is a game for PyWeek 13
    Copyright (C) 2011 D Haynes

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    tundish@thuswise.org
"""

GEOGRAPHY = {
"AB": ["Aberdeen", "Aberlour", "Aboyne", "Alford", "Ballater", "Ballindalloch", "Banchory", "Banff", "Buckie", "Ellon", "Fraserburgh", "Huntly", "Insch", "Inverurie", "Keith", "Laurencekirk", "Macduff", "Milltimber", "Peterculter", "Peterhead", "Stonehaven", "Strathdon", "Turriff", "Westhill"], "AL": ["Harpenden", "Hatfield", "St. Albans", "Welwyn", "Welwyn Garden City"],
"B": ["Alcester", "Birmingham", "Bromsgrove", "Cradley Heath", "Halesowen", "Henley-in-Arden", "Oldbury", "Redditch", "Rowley Regis", "Smethwick", "Solihull", "Studley", "Sutton Coldfield", "Tamworth", "West Bromwich"],
"BA": ["Bath", "Bradford-on-Avon", "Bruton", "Castle Cary", "Frome", "Glastonbury", "Radstock", "Shepton Mallet", "Street", "Templecombe", "Trowbridge", "Warminster", "Wells", "Westbury", "Wincanton", "Yeovil"],
"BB": ["Accrington", "Barnoldswick", "Blackburn", "Burnley", "Clitheroe", "Colne", "Darwen", "Nelson", "Rossendale"],
"BD": ["Bingley", "Bradford", "Cleckheaton", "Keighley", "Settle", "Shipley", "Skipton"],
"BH": ["Bournemouth", "Broadstone", "Christchurch", "Ferndown", "New Milton", "Poole", "Ringwood", "Swanage", "Verwood", "Wareham", "Wimborne"],
"BL": ["Bolton", "Bury"],
"BN": ["Arundel", "Brighton", "Eastbourne", "Hailsham", "Hassocks", "Henfield", "Hove", "Lancing", "Lewes", "Littlehampton", "Newhaven", "Peacehaven", "Pevensey", "Polegate", "Seaford", "Shoreham-by-Sea", "Steyning", "Worthing"],
"BR": ["Beckenham", "Bromley", "Chislehurst", "Keston", "Orpington", "Swanley", "West Wickham"],
"BS": ["Axbridge", "Banwell", "Bristol", "Cheddar", "Clevedon", "Wedmore", "Weston-super-Mare", "Winscombe"],
"BT": ["Antrim", "Armagh", "Augher", "Aughnacloy", "Ballycastle", "Ballyclare", "Ballymena", "Ballymoney", "Ballynahinch", "Banbridge", "Bangor", "Belfast", "Bushmills", "Caledon", "Carrickfergus", "Castlederg", "Castlewellan", "Clogher", "Coleraine", "Cookstown", "Craigavon", "Crumlin", "Donaghadee", "Downpatrick", "Dromore", "Dungannon", "Enniskillen", "Fivemiletown", "Hillsborough", "Holywood", "Larne", "Limavady", "Lisburn", "Londonderry", "Maghera", "Magherafelt", "Newcastle", "Newry", "Newtownabbey", "Newtownards", "Omagh", "Portrush", "Portstewart", "Strabane"],
"CA": ["Alston", "Appleby-in-Westmorland", "Beckermet", "Brampton", "Carlisle", "Cleator", "Cleator Moor", "Cockermouth", "Egremont", "Frizington", "Holmrook", "Keswick", "Kirkby Stephen", "Maryport", "Moor Row", "Penrith", "Ravenglass", "Seascale", "St. Bees", "Whitehaven", "Wigton", "Workington"],
"CB": ["Cambridge", "Ely", "Haverhill", "Newmarket", "Saffron Walden"],
"CF": ["Aberdare", "Bargoed", "Barry", "Bridgend", "Caerphilly", "Cardiff", "Cowbridge", "Dinas Powys", "Ferndale", "Hengoed", "Llantwit Major", "Maesteg", "Merthyr Tydfil", "Mountain Ash", "Penarth", "Pentre", "Pontyclun", "Pontypridd", "Porth", "Porthcawl", "Tonypandy", "Treharris", "Treorchy"],
"CH": ["Bagillt", "Birkenhead", "Buckley", "Chester", "Deeside", "Ellesmere Port", "Flint", "Holywell", "Mold", "Neston", "Prenton", "Wallasey", "Wirral"],
"CM": ["Billericay", "Bishop's Stortford", "Braintree", "Brentwood", "Burnham-on-Crouch", "Chelmsford", "Dunmow", "Epping", "Harlow", "Ingatestone", "Maldon", "Ongar", "Sawbridgeworth", "Southminster", "Stansted", "Witham"],
"CO": ["Bures", "Clacton-on-Sea", "Colchester", "Frinton-on-Sea", "Halstead", "Harwich", "Manningtree", "Sudbury", "Walton on the Naze"],
"CR": ["Caterham", "Coulsdon", "Croydon", "Kenley", "Mitcham", "Purley", "South Croydon", "Thornton Heath", "Warlingham", "Whyteleafe"],
"CT": ["Birchington", "Broadstairs", "Canterbury", "Deal", "Dover", "Folkestone", "Herne Bay", "Hythe", "Margate", "Ramsgate", "Sandwich", "Westgate-on-Sea", "Whitstable"],
"CV": ["Atherstone", "Bedworth", "Coventry", "Kenilworth", "Leamington Spa", "Nuneaton", "Rugby", "Shipston-on-Stour", "Southam", "Stratford-upon-Avon", "Warwick"],
"CW": ["Congleton", "Crewe", "Middlewich", "Nantwich", "Northwich", "Sandbach", "Tarporley", "Winsford"],
"DA": ["Belvedere", "Bexley", "Bexleyheath", "Dartford", "Erith", "Gravesend", "Greenhithe", "Longfield", "Sidcup", "Swanscombe", "Welling"],
"DD": ["Arbroath", "Brechin", "Carnoustie", "Dundee", "Forfar", "Kirriemuir", "Montrose", "Newport-on-Tay", "Tayport"],
"DE": ["Alfreton", "Ashbourne", "Bakewell", "Belper", "Burton-on-Trent", "Derby", "Heanor", "Ilkeston", "Matlock", "Ripley", "Swadlincote"],
"DG": ["Annan", "Canonbie", "Castle Douglas", "Dalbeattie", "Dumfries", "Gretna", "Kirkcudbright", "Langholm", "Lockerbie", "Moffat", "Newton Stewart", "Sanquhar", "Stranraer", "Thornhill"],
"DH": ["Chester le Street", "Consett", "Durham", "Houghton le Spring", "Stanley"],
"DL": ["Barnard Castle", "Bedale", "Bishop Auckland", "Catterick Garrison", "Crook", "Darlington", "Ferryhill", "Hawes", "Leyburn", "Newton Aycliffe", "Northallerton", "Richmond", "Shildon", "Spennymoor"],
"DN": ["Barnetby", "Barrow-upon-Humber", "Barton-upon-Humber", "Brigg", "Cleethorpes", "Doncaster", "Gainsborough", "Goole", "Grimsby", "Immingham", "Retford", "Scunthorpe", "Ulceby"],
"DT": ["Beaminster", "Blandford Forum", "Bridport", "Dorchester", "Lyme Regis", "Portland", "Sherborne", "Sturminster Newton", "Weymouth"],
"DY": ["Bewdley", "Brierley Hill", "Dudley", "Kidderminster", "Kingswinford", "Stourbridge", "Stourport-on-Severn", "Tipton"],
"E": ["East London", "Newham", "Redbridge", "Waltham Forest"],
"EC": ["East Central London", "Islington", "Pentonville", "Tufnell Park"],
"EH": ["Balerno", "Bathgate", "Bo'ness", "Bonnyrigg", "Broxburn", "Currie", "Dalkeith", "Dunbar", "East Linton", "Edinburgh", "Gorebridge", "Gullane", "Haddington", "Heriot", "Humbie", "Innerleithen", "Juniper Green", "Kirkliston", "Kirknewton", "Lasswade", "Linlithgow", "Livingston", "Loanhead", "Longniddry", "Musselburgh", "Newbridge", "North Berwick", "Pathhead", "Peebles", "Penicuik", "Prestonpans", "Rosewell", "Roslin", "South Queensferry", "Tranent", "Walkerburn", "West Calder", "West Linton"],
"EN": ["Barnet", "Broxbourne", "Enfield", "Hoddesdon", "Potters Bar", "Waltham Abbey", "Waltham Cross"],
"EX": ["Axminster", "Barnstaple", "Beaworthy", "Bideford", "Braunton", "Bude", "Budleigh Salterton", "Chulmleigh", "Colyton", "Crediton", "Cullompton", "Dawlish", "Exeter", "Exmouth", "Holsworthy", "Honiton", "Ilfracombe", "Lynmouth", "Lynton", "North Tawton", "Okehampton", "Ottery St. Mary", "Seaton", "Sidmouth", "South Molton", "Tiverton", "Torrington", "Umberleigh", "Winkleigh", "Woolacombe"],
"FK": ["Alloa", "Alva", "Bonnybridge", "Callander", "Clackmannan", "Crianlarich", "Denny", "Dollar", "Doune", "Dunblane", "Falkirk", "Grangemouth", "Killin", "Larbert", "Lochearnhead", "Menstrie", "Stirling", "Tillicoultry"],
"FY": ["Blackpool", "Fleetwood", "Lytham St. Annes", "Poulton-le-Fylde", "Thornton-Cleveleys"],
"G": ["Alexandria", "Arrochar", "Clydebank", "Dumbarton", "Glasgow", "Helensburgh"],
"GL": ["Badminton", "Berkeley", "Blakeney", "Cheltenham", "Chipping Campden", "Cinderford", "Cirencester", "Coleford", "Drybrook", "Dursley", "Dymock", "Fairford", "Gloucester", "Lechlade", "Longhope", "Lydbrook", "Lydney", "Mitcheldean", "Moreton-in-Marsh", "Newent", "Newnham", "Ruardean", "Stonehouse", "Stroud", "Tetbury", "Tewkesbury", "Westbury-on-Severn", "Wotton-under-Edge"],
"GU": ["Aldershot", "Alton", "Bagshot", "Bordon", "Camberley", "Cranleigh", "Farnborough", "Farnham", "Fleet", "Godalming", "Guildford", "Haslemere", "Hindhead", "Lightwater", "Liphook", "Liss", "Midhurst", "Petersfield", "Petworth", "Sandhurst", "Virginia Water", "Windlesham", "Woking", "Yateley"],
"HA": ["Edgware", "Harrow", "Northwood", "Pinner", "Ruislip", "Stanmore", "Wembley"],
"HD": ["Brighouse", "Holmfirth", "Huddersfield"],
"HG": ["Harrogate", "Knaresborough", "Ripon"],
"HP": ["Amersham", "Aylesbury", "Beaconsfield", "Berkhamsted", "Chalfont St." "Giles", "Chesham", "Great Missenden", "Hemel Hempstead", "High Wycombe", "Princes Risborough", "Tring"],
"HR": ["Bromyard", "Hereford", "Kington", "Ledbury", "Leominster", "Ross-on-Wye"],
"HS": ["Isle of Barra", "Isle of Benbecula", "Isle of Harris", "Isle of Lewis", "Isle of North Uist", "Isle of Scalpay", "Isle of South Uist", "Stornoway"],
"HU": ["Beverley", "Brough", "Cottingham", "Hessle", "Hornsea", "Hull", "North Ferriby", "Withernsea"],
"HX": ["Elland", "Halifax", "Hebden Bridge", "Sowerby Bridge"],
"IG": ["Barking", "Buckhurst Hill", "Chigwell", "Ilford", "Loughton", "Woodford Green"],
"IP": ["Aldeburgh", "Brandon", "Bury St. Edmunds", "Diss", "Eye", "Felixstowe", "Halesworth", "Harleston", "Ipswich", "Leiston", "Saxmundham", "Southwold", "Stowmarket", "Thetford", "Woodbridge"],
"IV": ["Achnasheen", "Alness", "Ardgay", "Avoch", "Beauly", "Cromarty", "Dingwall", "Dornoch", "Elgin", "Fochabers", "Forres", "Fortrose", "Gairloch", "Garve", "Invergordon", "Inverness", "Isle of Skye", "Kyle", "Lairg", "Lossiemouth", "Muir of Ord", "Munlochy", "Nairn", "Plockton", "Portree", "Rogart", "Strathcarron", "Strathpeffer", "Strome Ferry", "Tain", "Ullapool"],
"KA": ["Ardrossan", "Ayr", "Beith", "Cumnock", "Dalry", "Darvel", "Galston", "Girvan", "Irvine", "Isle of Arran", "Isle of Cumbrae", "Kilbirnie", "Kilmarnock", "Kilwinning", "Largs", "Mauchline", "Maybole", "Newmilns", "Prestwick", "Saltcoats", "Stevenston", "Troon", "West Kilbride"],
"KT": ["Addlestone", "Ashtead", "Chertsey", "Chessington", "Cobham", "East Molesey", "Epsom", "Esher", "Kingston upon Thames", "Leatherhead", "New Malden", "Surbiton", "Tadworth", "Thames Ditton", "Walton-on-Thames", "West Byfleet", "West Molesey", "Weybridge", "Worcester Park"],
"KW": ["Berriedale", "Brora", "Dunbeath", "Forsinard", "Golspie", "Halkirk", "Helmsdale", "Kinbrace", "Kirkwall", "Latheron", "Lybster", "Orkney", "Stromness", "Thurso", "Wick"],
"KY": ["Anstruther", "Burntisland", "Cowdenbeath", "Cupar", "Dunfermline", "Glenrothes", "Inverkeithing", "Kelty", "Kinross", "Kirkcaldy", "Leven", "Lochgelly", "St. Andrews"],
"L": ["Bootle", "Liverpool", "Ormskirk", "Prescot"],
"LA": ["Ambleside", "Askam-in-Furness", "Barrow-in-Furness", "Broughton-in-Furness", "Carnforth", "Coniston", "Dalton-in-Furness", "Grange-over-Sands", "Kendal", "Kirkby-in-Furness", "Lancaster", "Millom", "Milnthorpe", "Morecambe", "Sedbergh", "Ulverston", "Windermere"],
"LD": ["Brecon", "Builth Wells", "Knighton", "Llandrindod Wells", "Llangammarch Wells", "Llanwrtyd Wells", "Presteigne", "Rhayader"],
"LE": ["Ashby-de-la-Zouch", "Coalville", "Hinckley", "Ibstock", "Leicester", "Loughborough", "Lutterworth", "Market Harborough", "Markfield", "Melton Mowbray", "Oakham", "Wigston"],
"LL": ["Aberdovey", "Abergele", "Amlwch", "Arthog", "Bala", "Bangor", "Barmouth", "Beaumaris", "Betws-y-Coed", "Blaenau Ffestiniog", "Bodorgan", "Brynteg", "Caernarfon", "Cemaes Bay", "Colwyn Bay", "Conwy", "Corwen", "Criccieth", "Denbigh", "Dolgellau", "Dolwyddelan", "Dulas", "Dyffryn Ardudwy", "Fairbourne", "Gaerwen", "Garndolbenmaen", "Harlech", "Holyhead", "Llanbedr", "Llanbedrgoch", "Llandudno", "Llandudno Junction", "Llanerchymedd", "Llanfairfechan", "Llanfairpwllgwyngyll", "Llangefni", "Llangollen", "Llanrwst", "Llwyngwril", "Marianglas", "Menai Bridge", "Moelfre", "Penmaenmawr", "Penrhyndeudraeth", "Pentraeth", "Penysarn", "Porthmadog", "Prestatyn", "Pwllheli", "Rhosgoch", "Rhosneigr", "Rhyl", "Ruthin", "St. Asaph", "Talsarnau", "Talybont", "Trefriw", "Ty Croes", "Tyn-y-Gongl", "Tywyn", "Wrexham", "Y Felinheli"],
"LN": ["Alford", "Horncastle", "Lincoln", "Louth", "Mablethorpe", "Market Rasen", "Woodhall Spa"],
"LS": ["Ilkley", "Leeds", "Otley", "Pudsey", "Tadcaster", "Wetherby"],
"LU": ["Dunstable", "Leighton Buzzard", "Luton"],
"M": ["Manchester", "Sale", "Salford"],
"ME": ["Aylesford", "Chatham", "Faversham", "Gillingham", "Maidstone", "Queenborough", "Rochester", "Sheerness", "Sittingbourne", "Snodland", "West Malling"],
"MK": ["Bedford", "Buckingham", "Milton Keynes", "Newport ""Pagnell", "Olney"],
"ML": ["Airdrie", "Bellshill", "Biggar", "Carluke", "Coatbridge", "Hamilton", "Lanark", "Larkhall", "Motherwell", "Shotts", "Strathaven", "Wishaw"],
"N": ["North London", "Fortis Green", "Noel Park", "Tottenham Green"],
"NE": ["Alnwick", "Ashington", "Bamburgh", "Bedlington", "Belford", "Blaydon-on-Tyne", "Blyth", "Boldon Colliery", "Chathill", "Choppington", "Corbridge", "Cramlington", "East Boldon", "Gateshead", "Haltwhistle", "Hebburn", "Hexham", "Jarrow", "Morpeth", "Newbiggin-by-the-Sea", "Newcastle upon Tyne", "North Shields", "Prudhoe", "Riding Mill", "Rowlands Gill", "Ryton", "Seahouses", "South Shields", "Stocksfield", "Wallsend", "Washington", "Whitley Bay", "Wooler", "Wylam"],
"NG": ["Grantham", "Mansfield", "Newark", "Nottingham", "Sleaford", "Southwell", "Sutton-in-Ashfield"],
"NN": ["Brackley", "Corby", "Daventry", "Kettering", "Northampton", "Rushden", "Towcester", "Wellingborough"],
"NP": ["Abergavenny", "Abertillery", "Blackwood", "Caldicot", "Chepstow", "Crickhowell", "Cwmbran", "Ebbw Vale", "Monmouth", "New Tredegar", "Newport", "Pontypool", "Tredegar", "Usk"],
"NR": ["Attleborough", "Beccles", "Bungay", "Cromer", "Dereham", "Fakenham", "Great Yarmouth", "Holt", "Lowestoft", "Melton Constable", "North Walsham", "Norwich", "Sheringham", "Walsingham", "Wells-next-the-Sea", "Wymondham"],
"NW": ["North West London", "Brondesbury Park", "Harlesden", "Neasden", "Queen's Park", "Welsh Harp"],
"OL": ["Ashton-under-Lyne", "Bacup", "Heywood", "Littleborough", "Oldham", "Rochdale", "Todmorden"],
"OX": ["Abingdon", "Bampton", "Banbury", "Bicester", "Burford", "Carterton", "Chinnor", "Chipping Norton", "Didcot", "Kidlington", "Oxford", "Thame", "Wallingford", "Wantage", "Watlington", "Witney", "Woodstock"], "PA": ["Appin", "Bishopton", "Bridge of Orchy", "Bridge of Weir", "Cairndow", "Campbeltown", "Colintraive", "Dalmally", "Dunoon", "Erskine", "Gourock", "Greenock", "Inveraray", "Isle of Bute", "Isle of Coll", "Isle of Colonsay", "Isle of Gigha", "Isle of Iona", "Isle of Islay", "Isle of Jura", "Isle of Mull", "Isle of Tiree", "Johnstone", "Kilmacolm", "Lochgilphead", "Lochwinnoch", "Oban", "Paisley", "Port Glasgow", "Renfrew", "Skelmorlie", "Tarbert", "Taynuilt", "Tighnabruaich", "Wemyss Bay"],
"PE": ["Boston", "Bourne", "Chatteris", "Downham Market", "Hunstanton", "Huntingdon", "King's Lynn", "March", "Peterborough", "Sandringham", "Skegness", "Spalding", "Spilsby", "St. Ives", "St. Neots", "Stamford", "Swaffham", "Wisbech"],
"PH": ["Aberfeldy", "Acharacle", "Arisaig", "Auchterarder", "Aviemore", "Ballachulish", "Blairgowrie", "Boat of Garten", "Carrbridge", "Corrour", "Crieff", "Dalwhinnie", "Dunkeld", "Fort Augustus", "Fort William", "Glenfinnan", "Grantown-on-Spey", "Invergarry", "Isle of Canna", "Isle of Eigg", "Isle of Rum", "Kingussie", "Kinlochleven", "Lochailort", "Mallaig", "Nethy Bridge", "Newtonmore", "Perth", "Pitlochry", "Roy Bridge", "Spean Bridge"],
"PL": ["Bodmin", "Boscastle", "Callington", "Calstock", "Camelford", "Delabole", "Fowey", "Gunnislake", "Ivybridge", "Launceston", "Lifton", "Liskeard", "Looe", "Lostwithiel", "Padstow", "Par", "Plymouth", "Port Isaac", "Saltash", "St. Austell", "Tavistock", "Tintagel", "Torpoint", "Wadebridge", "Yelverton"],
"PO": ["Bembridge", "Bognor Regis", "Chichester", "Cowes", "East Cowes", "Emsworth", "Fareham", "Freshwater", "Gosport", "Havant", "Hayling Island", "Lee-on-the-Solent", "Newport", "Portsmouth", "Rowland's Castle", "Ryde", "Sandown", "Seaview", "Shanklin", "Southsea", "Totland Bay", "Ventnor", "Waterlooville", "Yarmouth"],
"PR": ["Chorley", "Leyland", "Preston", "Southport"],
"RG": ["Basingstoke", "Bracknell", "Crowthorne", "Henley-on-Thames", "Hook", "Hungerford", "Newbury", "Reading", "Tadley", "Thatcham", "Whitchurch", "Wokingham"],
"RH": ["Betchworth", "Billingshurst", "Burgess Hill", "Crawley", "Dorking", "East Grinstead", "Forest Row", "Gatwick", "Godstone", "Haywards Heath", "Horley", "Horsham", "Lingfield", "Oxted", "Pulborough", "Redhill", "Reigate"],
"RM": ["Dagenham", "Grays", "Hornchurch", "Purfleet", "Rainham", "Romford", "South Ockendon", "Tilbury", "Upminster"],
"S": ["Barnsley", "Chesterfield", "Dronfield", "Hope Valley", "Mexborough", "Rotherham", "Sheffield", "Worksop"],
"SA": ["Aberaeron", "Ammanford", "Boncath", "Burry Port", "Cardigan", "Carmarthen", "Clarbeston Road", "Clynderwen", "Crymych", "Ferryside", "Fishguard", "Glogue", "Goodwick", "Haverfordwest", "Kidwelly", "Kilgetty", "Lampeter", "Llanarth", "Llandeilo", "Llandovery", "Llandysul", "Llanelli", "Llanfyrnach", "Llangadog", "Llanwrda", "Llanybydder", "Milford Haven", "Narberth", "Neath", "New Quay", "Newcastle Emlyn", "Newport", "Pembroke", "Pembroke Dock", "Pencader", "Port Talbot", "Saundersfoot", "Swansea", "Tenby", "Whitland"],
"SE": ["SE London", "Blackheath", "Deptford", "Rotherhithe", "Woolwich", "Tulse Hill"],
"SG": ["Arlesey", "Baldock", "Biggleswade", "Buntingford", "Henlow", "Hertford", "Hitchin", "Knebworth", "Letchworth Garden City", "Much Hadham", "Royston", "Sandy", "Shefford", "Stevenage", "Ware"],
"SK": ["Alderley Edge", "Buxton", "Cheadle", "Dukinfield", "Glossop", "High Peak", "Hyde", "Macclesfield", "Stalybridge", "Stockport", "Wilmslow"],
"SL": ["Ascot", "Bourne End", "Gerrards Cross", "Iver", "Maidenhead", "Marlow", "Slough", "Windsor"],
"SM": ["Banstead", "Carshalton", "Morden", "Sutton", "Wallington"],
"SN": ["Calne", "Chippenham", "Corsham", "Devizes", "Faringdon", "Malmesbury", "Marlborough", "Melksham", "Pewsey", "Swindon"],
"SO": ["Alresford", "Brockenhurst", "Eastleigh", "Lymington", "Lyndhurst", "Romsey", "Southampton", "Stockbridge", "Winchester"],
"SP": ["Andover", "Fordingbridge", "Gillingham", "Salisbury", "Shaftesbury", "Tidworth"],
"SR": ["Peterlee", "Seaham", "Sunderland"],
"SS": ["Basildon", "Benfleet", "Canvey Island", "Hockley", "Leigh-on-Sea", "Rayleigh", "Rochford", "Southend-on-Sea", "Stanford-le-Hope", "Westcliff-on-Sea", "Wickford"],
"ST": ["Leek", "Newcastle", "Stafford", "Stoke-on-Trent", "Stone", "Uttoxeter"],
"SW": ["South West London", "Fulham", "Sand's End", "White City"],
"SY": ["Aberystwyth", "Bishops Castle", "Borth", "Bow Street", "Bucknell", "Caersws", "Church Stretton", "Craven Arms", "Ellesmere", "Llanbrynmair", "Llandinam", "Llanfechain", "Llanfyllin", "Llanidloes", "Llanon", "Llanrhystud", "Llansanffraid", "Llanymynech", "Ludlow", "Lydbury North", "Machynlleth", "Malpas", "Meifod", "Montgomery", "Newtown", "Oswestry", "Shrewsbury", "Talybont", "Tregaron", "Welshpool", "Whitchurch", "Ystrad Meurig"],
"TA": ["Bridgwater", "Burnham-on-Sea", "Chard", "Crewkerne", "Dulverton", "Highbridge", "Hinton St. George", "Ilminster", "Langport", "Martock", "Merriott", "Minehead", "Montacute", "Somerton", "South Petherton", "Stoke-sub-Hamdon", "Taunton", "Watchet", "Wellington"],
"TD": ["Berwick-upon-Tweed", "Cockburnspath", "Coldstream", "Cornhill-on-Tweed", "Duns", "Earlston", "Eyemouth", "Galashiels", "Gordon", "Hawick", "Jedburgh", "Kelso", "Lauder", "Melrose", "Mindrum", "Newcastleton", "Selkirk"],
"TF": ["Broseley", "Market Drayton", "Much Wenlock", "Newport", "Shifnal", "Telford"],
"TN": ["Ashford", "Battle", "Bexhill-on-Sea", "Cranbrook", "Crowborough", "Edenbridge", "Etchingham", "Hartfield", "Hastings", "Heathfield", "Mayfield", "New Romney", "Robertsbridge", "Romney Marsh", "Rye", "Sevenoaks", "St. Leonards-on-Sea", "Tenterden", "Tonbridge", "Tunbridge Wells", "Uckfield", "Wadhurst", "Westerham", "Winchelsea"],
"TQ": ["Brixham", "Buckfastleigh", "Dartmouth", "Kingsbridge", "Newton Abbot", "Paignton", "Salcombe", "South Brent", "Teignmouth", "Torquay", "Totnes"],
"TR": ["Camborne", "Falmouth", "Hayle", "Helston", "Isles of Scilly", "Marazion", "Newquay", "Penryn", "Penzance", "Perranporth", "Redruth", "St. Agnes", "St. Columb", "St. Ives", "Truro"],
"TS": ["Billingham", "Guisborough", "Hartlepool", "Middlesbrough", "Redcar", "Saltburn-by-the-Sea", "Stockton-on-Tees", "Trimdon Station", "Wingate", "Yarm"],
"TW": ["Ashford", "Brentford", "Egham", "Feltham", "Hampton", "Hounslow", "Isleworth", "Richmond", "Shepperton", "Staines", "Sunbury-on-Thames", "Teddington", "Twickenham"],
"UB": ["Greenford", "Hayes", "Northolt", "Southall", "Uxbridge", "West Drayton"],
"W": ["West London", "Brompton", "Ladbroke Grove", "Notting Hill", "World's End"],
"WA": ["Altrincham", "Frodsham", "Knutsford", "Lymm", "Newton-le-Willows", "Runcorn", "St. Helens", "Warrington", "Widnes"],
"WC": ["West Central London", "Bayswater", "Lisson Grove", "Millbank", "Pimlico", "Victoria"],
"WD": ["Abbots Langley", "Borehamwood", "Bushey", "Kings Langley", "Radlett", "Rickmansworth", "Watford"],
"WF": ["Batley", "Castleford", "Dewsbury", "Heckmondwike", "Knottingley", "Liversedge", "Mirfield", "Normanton", "Ossett", "Pontefract", "Wakefield"],
"WN": ["Leigh", "Skelmersdale", "Wigan"],
"WR": ["Broadway", "Droitwich", "Evesham", "Malvern", "Pershore", "Tenbury Wells", "Worcester"],
"WS": ["Burntwood", "Cannock", "Lichfield", "Rugeley", "Walsall", "Wednesbury"],
"WV": ["Bilston", "Bridgnorth", "Willenhall", "Wolverhampton"],
"YO": ["Bridlington", "Driffield", "Filey", "Malton", "Pickering", "Scarborough", "Selby", "Thirsk", "Whitby", "York"],
"ZE": ["Shetland", "Sumburgh"]
}

TOPOLOGY = {
"AB": ["IV","DD"],
"AL": ["LU","SG","EN","WD"],
"B": ["WS","DE","CV","WR","DY"],
"BA": ["BS","SN","SP","DT","TA"],
"BB": ["LA","BD","BL","PR"],
"BD": ["LA","DL","HG","LS","HD","HX","BB"],
"BH": ["DT","SP","SO"],
"BL": ["PR","BB","OL","M","WN"],
"BN": ["RH","TN","PO"],
"BR": ["SE","DA","RH","CR"],
"BS": ["NP","GL","SN","BA","TA"],
"BT": [""],
"CA": ["DG","TD","NE","DL","LA"],
"CB": ["PE","IP","CO","CM","SG"],
"CF": ["SA","LD","NP"],
"CH": ["L","WA","CW","SY","LL"],
"CM": ["CB","CO","SS","RM"],
"CO": ["CB","IP","CM"],
"CR": ["SM","BR","TN","RH","KT"],
"CT": ["ME","TN"],
"CV": ["B","DE","LE","NN","OX","GL"],
"CW": ["WA","SX","ST","TF"],
"DA": ["SE","RM","ME","TN","RH"],
"DD": ["PH", "AB"],
"DE": ["SK","S","NG","LE","CV","B","WS","ST"],
"DG": ["KA","ML","TD","CA"],
"DH": ["NE","SR","TS","DL"],
"DL": ["CA","NE","DH","TS","YO","HG","BD","LA","CA"],
"DN": ["WF","YO","HU","LN","NG","S"],
"DT": ["EX","TA","BA","SP","BH"],
"DY": ["WV","WS","B","WR","SY"],
"E": ["N","EC","S","SE","W"],
"EC": ["N","C","S","SE","W"],
"EH": ["FK","KY","TD","ML"],
"EN": ["AL","SG","IG","N","NW","HA","WD"],
"EX": ["TA","DT","EX"],
"FK": ["PH", "PA", "G", "ML", "EH", "KY"],
"FY": ["PR"],
"G": ["PA", "FK", "ML", "KA"],
"GL": ["HR","WR","CV","OX","SN","BS","NP"],
"GU": ["RG","SL","KT","RH","BN","PO","SO"],
"HA": ["WD","EN","NW","UB"],
"HD": ["HX","BD","LS","WF","S","OL"],
"HG": ["DL","YO","LS","BD"],
"HP": ["MK","LU","AL","NW","SL","RG","OX"],
"HR": ["SY","WR","GL","NP"],
"HS": [],
"HU": ["YO","DN"],
"HX": ["BD","HD","OL","BB"],
"IG": ["EN","CM","RM","N"],
"IP": ["PE","NR","CO","CB"],
"IV": ["KW", "PH", "AB"],
"KA": ["G","ML","DG"],
"KT": ["TW","SM","CR","RH","GU","SL"],
"KW": ["IV"],
"KY": ["PH","FK","EH"],
"L": ["PR","WN","WA","CH"],
"LA": ["CA","DL","BD","BB","PR"],
"LD": ["SY","HR","NP","CF","SA"],
"LE": ["NG","PE","NN","CV","DE"],
"LL": ["CH","SY"],
"LN": ["DN","PE","NG"],
"LS": ["HG","YO","WF","HD","BD"],
"LU": ["MK","SG","AL","HP"],
"M": ["BL","OL","SK","WA","WN"],
"ME": ["DA","RM","SS","CT","TN"],
"MK": ["NN","PE","SG","LU","HP","OX"],
"ML": ["G","FK","EH","TD","DG","KA"],
"N": ["EC","S","SE","W","NW","HA","EN","IG"],
"NE": ["TD","SR","DH","DL","CA"],
"NG": ["S","DN","LN","PE","LE","DE"],
"NN": ["CV","LE","PE","MK","OX"],
"NP": ["LO","HR","GL","CF"],
"NR": ["PE","IP"],
"NW": ["N","HA","EN"],
"OL": ["BB","HX","HD","S","SK","M","BL"],
"OX": ["CV","NN","MK","HP","RG","SN","GL"],
"PA": ["PH","FK","G"],
"PE": ["NG","LN","NR","IP","CB","SG","MK","NN","LE"],
"PH": ["IV", "AB", "DD", "KY", "FK", "PA"],
"PL": ["TR","EX","TQ"],
"PO": ["SO","GU","BN"],
"PR": ["FY","LA","BB","BL","WN","L"],
"RG": ["OX","HP","SL","GU","SO","SP","SN"],
"RH": ["KT","CR","BR","TN","BN","GU"],
"RM": ["IG","CM","SS","ME","DA"],
"S": ["HD","WF","DN","NG","DE","SK","OL"],
"SA": ["SY","LD","CF"],
"SE": ["EC","S","SM","W","NW","HA","BR","DA"],
"SG": ["MK","PE","CB","CM","EN","AL","LU"],
"SK": ["M","OL","S","DE","ST","CW","WA"],
"SL": ["HP","WD","UB","GU","RG"],
"SM": ["SW","S","CR","KT","TW"],
"SN": ["GL","OX","RG","SP","BA","BS"],
"SO": ["SP","RG","GU","PO","BH"],
"SP": ["BA","SN","SO","BH","DT"],
"SR": ["NE","TS","DH"],
"SS": ["CM","RM","ME"],
"ST": ["CW","SK","DE","WS","WV","TF"],
"SW": ["S","SM","W","NW","UB","TW"],
"SY": ["LL","CH","CW","TF","WV","HR","LD","SA"],
"TA": ["BS","BA","DT","EX"],
"TD": ["EH","NE","CA","DG""ML"],
"TF": ["CW","ST","WV","SY"],
"TN": ["CR","BR","DA","ME","CT","BN","RH"],
"TQ": ["PL","EX"],
"TR": ["PL"],
"TS": ["DH","SR","YO","DL"],
"TW": ["HA","SL","UB","SM","CR","KT"],
"UB": ["HP","SL","TW","SM","CR","W"],
"W": ["HA","SL","TW","WC","NW","CR","UB"],
"WA": ["L","WN","M","SK","CW","CH"],
"WC": ["N","E","S","W","NW"],
"WD": ["SL","HP","AL","EN","HA","UB"],
"WF": ["LS","YO","DN","S","HD","BD"],
"WN": ["PR","BL","M","WA","L"],
"WR": ["DY","B","CV","GL","HR","SY"],
"WS": ["ST","DE","B","DY","WV"],
"WV": ["SY","TF","ST","WS","DY"],
"YO": ["DL","TS","HU","DN","WF","LS","HG"],
"ZE": []
}

POPULATION = {
"AB": None,
"AL": 539200,
"B": 630000,
"BA": 387100,
"BB": 389700,
"BD": 366750,
"BH": 407800,
"BL": 514700,
"BN": 781600,
"BR": 422883,
"BS": 421300,
"BT": None,
"CA": 496600,
"CB": 605100,
"CF": 232100,
"CH": 328600,
"CM": 698150,
"CO": 698150,
"CR": 422883,
"CT": 232100,
"CV": 630000,
"CW": 196200,
"DA": 422883,
"DD": None,
"DE": 1001500,
"DG": None,
"DH": 508500,
"DL": 318500,
"DN": 652950,
"DT": 163900,
"DY": 630000,
"E": 422883,
"EC": 422883,
"EH": None,
"EN": 422883,
"EX": 335866,
"FK": None,
"FY": 389700,
"G": None,
"GL": 840200,
"GU": 1109700,
"HA": 422883,
"HD": 366750,
"HG": 366750,
"HP": 308500,
"HR": 179300,
"HS": None,
"HU": 593700,
"HX": 366750,
"IG": 422883,
"IP": 715700,
"IV": None,
"KA": None,
"KT": 422883,
"KW": None,
"KY": None,
"L": 1347800,
"LA": 389700,
"LD": None,
"LE": 940500,
"LL": None,
"LN": 698100,
"LS": 366750,
"LU": 446800,
"M": 514700,
"ME": 253500,
"MK": 725400,
"ML": None,
"N": 422883,
"NE": 546700,
"NG": 1068900,
"NN": 685000,
"NP": None,
"NR": 850800,
"NW": 422883,
"OL": 514700,
"OX": 639700,
"PA": None,
"PE": 164000,
"PH": None,
"PL": 335866,
"PO": 200000,
"PR": 389700,
"RG": 1431700,
"RH": 424700,
"RM": 422883,
"S": 652950,
"SA": None,
"SE": 422883,
"SG": 539200,
"SK": 514700,
"SL": 280300,
"SM": 422883,
"SN": 648400,
"SO": 234600,
"SP": 500000,
"SR": 546700,
"SS": 164300,
"ST": 1069000,
"SW": 422883,
"SY": 114700,
"TA": 782400,
"TD": 311000,
"TF": 354900,
"TN": 509800,
"TQ": 335866,
"TR": 532200,
"TS": 191900,
"TW": 422883,
"UB": 422883,
"W": 422883,
"WA": 361500,
"WC": 361500,
"WD": 422883,
"WF": 366750,
"WN": 514700,
"WR": 557600,
"WS": 630000,
"WV": 630000,
"YO": 794700,
"ZE": None
}

assert min(len(i) for i in GEOGRAPHY.values()) > 1

